#include <iostream>
#include <string>
#include <vector>

using namespace std;

int main()
{
    int brp,O,A,B,AB,ai;
    string tren;
    cin >> brp;
    vector<int> kO(brp,0),kA(brp,0),kB(brp,0),kAB(brp,0);
    cin >> O >> A >> B >> AB;
    for(int i=0;i<brp;i++){
        cin >> tren >> ai;
        if(tren=="O"){
            if(O-ai<0){
                cout << "nemoguce" << endl;
                return 0;
            }
            else{
                O-=ai;
                kO[i]=ai;
            }
        }
        else if(tren=="A"){
            if(A-ai>=0){
                kA[i]=ai;
                A-=ai;
            }
            else if(A+O-ai>=0){
                ai-=A;
                kA[i]=A;
                A=0;
                kO[i]=ai;
                O-=ai;
            }
            else{
                cout << "nemoguce" << endl;
                return 0;
            }
        }
        else if(tren=="B"){
            if(B-ai>=0){
                kB[i]=ai;
                B-=ai;
            }
            else if(B+O-ai>=0){
                ai-=B;
                kB[i]=B;
                B=0;
                kO[i]=ai;
                O-=ai;
            }
            else{
                cout << "nemoguce" << endl;
                return 0;
            }
        }
        else{
            kAB[i]=ai;
        }
    }
    for(int i=0;i<brp;i++){
        if(kAB[i]>0){
            ai=kAB[i];
            if(AB+A+B+O-ai>=0){
                if(AB<ai){
                    ai-=AB;
                    kAB[i]=AB;
                    AB=0;
                }
                else{
                    AB-=ai;
                    kAB[i]=ai;
                }
                if(A<ai){
                    ai-=A;
                    kA[i]=A;
                    A=0;
                }
                else{
                    A-=ai;
                    kA[i]=ai;
                    ai=0;
                }
                if(B<ai){
                    ai-=B;
                    kB[i]=B;
                    B=0;
                }
                else{
                    B-=ai;
                    kB[i]=ai;
                    ai=0;
                }
                if(O<ai){
                    ai-=O;
                    kO[i]=O;
                    O=0;
                }
                else{
                    O-=ai;
                    kO[i]=ai;
                    ai=0;
                }
            }
            else{
                cout << "nemoguce" << endl;
                return 0;
            }
        }
    }
    cout << "moguce" << endl;
    for(int i=0;i<brp;i++){
        cout << kO[i] << " " << kA[i] << " " << kB[i] << " " << kAB[i] <<" "<< endl;
    }
    return 0;
}